<template>
  <div class="field__wrapper">
    <img :src="icon" :alt="label" v-show="!!icon" class="field__icon" />
    <Dropdown
      :id="id"
      v-model="model"
      :options="options"
      optionLabel="name"
      class="field select"
      @change="$emit('validate-input', $event)"
    />
    <label :for="id" class="field__label">{{ label }}</label>
    <small class="field__error" v-if="!!error">{{ error }}</small>
  </div>
</template>
<script>
import Dropdown from "primevue/dropdown"
import { computed } from "vue"
export default {
  name: "Select",
  props: {
    id: {
      type: String,
      required: true,
    },
    label: {
      type: String,
      required: true,
    },
    options: {
      type: Array,
      required: true,
    },
    modelValue: {
      type: Object || null,
    },
    icon: {
      type: String,
    },
    error: {
      type: String,
    },
  },
  components: {
    Dropdown,
  },
  emits: ["update:modelValue", "validate-input"],
  setup(props, { emit }) {
    const model = computed({
      get: () => props.modelValue ?? "",
      set: newValue => emit("update:modelValue", newValue),
    })
    return { model }
  },
}
</script>
